#include "joystick.h"
#include "osd.h"


////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
cJoy::cJoy( void )
{
	JID[0] = JID[1] = -1;
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
cJoy::~cJoy( void )
{
	// I[vĂN[Y
	for( int i=0; i < OSD_GetJoyNum(); i++ )
		if( OSD_OpenedJoy( i ) ) OSD_CloseJoy( i );
}


////////////////////////////////////////////////////////////////
// 
//
// :	Ȃ
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL cJoy::Init( void )
{
	// I[vĂN[Y
	for( int i=0; i < OSD_GetJoyNum(); i++ )
		if( OSD_OpenedJoy( i ) ) OSD_CloseJoy( i );
	
	Connect( 0, 0 );
	Connect( 1, 1 );
	
	return TRUE;
}



////////////////////////////////////////////////////////////////
// WCXeBbNڑ
//
// :	jno		WCXeBbNԍ(0-1)
//			index	CfbNX
// Ԓl:	BOOL	TRUE: FALSE:s
////////////////////////////////////////////////////////////////
BOOL cJoy::Connect( int jno, int index )
{
	if( jno == 0 || jno == 1 ){
		if( index >= 0 && index < OSD_GetJoyNum() ){
			if( !OSD_OpenedJoy( index ) ) OSD_OpenJoy( index );
			if( OSD_OpenedJoy( index ) ){
				JID[jno] = index;
				return TRUE;
			}
		}
		JID[jno] = -1;
	}
	
	return FALSE;
}


////////////////////////////////////////////////////////////////
// CfbNX擾
//
// :	jno		WCXeBbNԍ(0-1)
// Ԓl:	int		CfbNX
////////////////////////////////////////////////////////////////
int cJoy::GetID( int jno )
{
	return 	( jno == 0 || jno == 1 ) ? JID[jno] : -1;
}


////////////////////////////////////////////////////////////////
// WCXeBbNԎ擾
//
// :	jno		WCXeBbNԍ(0-1)
// Ԓl:	BYTE	WCXeBbN̏ 1:OFF 0:ON <-!
//				bit7: {^4
//				bit6: {^3
//				bit5: {^2
//				bit4: {^1
//				bit3: E
//				bit2: 
//				bit1: 
//				bit0: 
////////////////////////////////////////////////////////////////
BYTE cJoy::GetJoyState( int jno )
{
	BYTE ret = 0;
	
	if( jno == 0 || jno == 1 ){
		if( JID[jno] >= 0 ){
			int Xmove, Ymove;
			
			// 
			Xmove = OSD_GetJoyAxis( JID[jno], 0 );
			Ymove = OSD_GetJoyAxis( JID[jno], 1 );
			
			if( Xmove < -16384 ) ret |= 4;	// 
			if( Xmove >  16384 ) ret |= 8;	// E
			if( Ymove < -16384 ) ret |= 1;	// 
			if( Ymove >  16384 ) ret |= 2;	// 
			
			// {^
			for( int i=0; i < min( OSD_GetJoyNumButtons( JID[jno] ), 4 ); i++ )
				if( OSD_GetJoyButton( JID[jno], i ) ) ret |= 0x10<<i;
		}
	}
	
	return ~ret;
}
