#ifndef OSD_H_INCLUDED
#define OSD_H_INCLUDED

// OSˑ̔ėp[`(UIp)

#include "typedef.h"
#include "keydef.h"


#ifdef __cplusplus
extern "C" 
{
#endif

// t@CI_CAOp
enum FileMode{ FM_Load, FM_Save };
enum FileDlg{ FD_TapeLoad, FD_TapeSave, FD_Disk, FD_ExtRom, FD_Printer, FD_FontZ, FD_FontH,
			  FD_DokoLoad, FD_DokoSave, FD_RepLoad, FD_RepSave, FD_AVISave, FD_LoadAll, EndofFileDlg };

// --- 񑀍֐ ---
// ɂ镶r
//   stricmp ֐ not ANSI,not POSIXłBMS̓Ǝg?
#ifndef stricmp
int stricmp ( const char *, const char * );
#endif

// --- pX֐ ---
// pX̃f~^'/'ɕϊ
void Delimiter( char * );
// pX̃f~^OSftHgɕϊ(WindowsȂ'\')
void UnDelimiter( char * );
// pX̖Ƀf~^ǉ
void AddDelimiter( char * );
// pX̖̃f~^폜
void DelDelimiter( char * );

// --- vZXǗ֐ ---
// dN`FbN
BOOL OSD_IsWorking();
// I
void OSD_Finish();

// --- t@C֐ ---
// W[pX擾
const char *OSD_GetModulePath();
// t@C̑݃`FbN
BOOL OSD_FileExist( const char * );
// t@C̓ǎp`FbN
BOOL OSD_FileReadOnly( const char * );
// tpXt@C擾
const char *OSD_GetFileNamePart( const char * );
// tH_̎Q
const char *OSD_FolderDiaog( void *, char * );
// t@C̎Q
const char *OSD_FileDiaog( void *, FileMode, const char *, const char *, char *, char *, const char * );
// et@CI
const char *OSD_FileSelect( void *, FileDlg, char *, char * );

// --- bZ[W\֐ ---
// bZ[W\
int OSD_Message( const char *, const char *, int );

// --- L[͏֐ ---
// L[s[gݒ
void OSD_SetKeyRepeat( int );
// OSDL[R[h -> zL[R[hϊ
int OSD_ConvertKeyCode( int );

// --- WCXeBbN֐ ---
#define	MAX_JOY			(8)
// p\ȃWCXeBbN擾
int OSD_GetJoyNum();
// WCXeBbN擾
const char *OSD_GetJoyName( int );
// WCXeBbNI[vĂH
BOOL OSD_OpenedJoy( int );
// WCXeBbNI[v
BOOL OSD_OpenJoy( int );
// WCXeBbNN[Y
void OSD_CloseJoy( int );
// WCXeBbN̎̐擾
int OSD_GetJoyNumAxes( int );
// WCXeBbÑ{^̐擾
int OSD_GetJoyNumButtons( int );
// WCXeBbN̎̏Ԏ擾
int OSD_GetJoyAxis( int, int );
// WCXeBbÑ{^̏Ԏ擾
BOOL OSD_GetJoyButton( int, int );

// --- TEh֘A֐ ---
// I[fBIfoCXI[v
BOOL OSD_OpenAudio( void *, void (*)(void *, BYTE *, int ), int, int );
// I[fBIfoCXN[Y
void OSD_CloseAudio();
// ĐJn
void OSD_StartAudio();
// Đ~
void OSD_StopAudio();
// Wavet@CǍ
BOOL OSD_LoadWAV( const char *, BYTE **, DWORD *, int * );
// Wavet@CJ
void OSD_FreeWAV( BYTE * );

// --- ^C}֐ ---
// w莞ԑҋ@
void OSD_Delay( DWORD );
// vZXJňoߎԎ擾
DWORD OSD_GetTicks();


// --- ̑̎G֐ ---
// 
BOOL OSD_Init();
// F̖O擾
const char *OSD_ColorName( int );
// L[̖O擾
const char *OSD_KeyName( PCKEYsym );
// tHgt@C쐬
BOOL OSD_CreateFont( char *, char *, int );


// bZ[W{bNX̃^Cv
#define	OSDM_OK				0x000
#define	OSDM_OKCANCEL		0x001
#define	OSDM_YESNO			0x002
#define	OSDM_YESNOCANCEL	0x003

// bZ[W{bNX̃ACR^Cv
#define	OSDM_ICONERROR		0x010
#define	OSDM_ICONQUESTION	0x020
#define	OSDM_ICONWARNING	0x030
#define	OSDM_ICONINFO		0x040

// bZ[W{bNX̖߂l
#define	OSDR_OK				0x00
#define	OSDR_CANCEL			0x01
#define	OSDR_YES			0x02
#define	OSDR_NO				0x03


// --- bZ[Wz ---
// ʃbZ[W
extern const char *MsgStr[];
#define	MSG_QUIT			MsgStr[0]	// "IĂ낵ł?"
#define	MSG_QUITC			MsgStr[1]	// "ImF"
#define	MSG_RESTART0		MsgStr[2]	// "ċNĂ낵ł?"
#define	MSG_RESTART			MsgStr[3]	// "ύX͍ċNɗLƂȂ܂B\nċN܂?"
#define	MSG_RESTARTC		MsgStr[4]	// "ċNmF"
#define	MSG_RESETI			MsgStr[5]	// "gROM}ăZbg܂B"
#define	MSG_RESETE			MsgStr[6]	// "gROMroăZbg܂B"
#define	MSG_RESETC			MsgStr[7]	// "ZbgmF"


// j[pbZ[W ------
extern const char *MsgMen[];
// [VXe]
#define	MSMEN_AVI0			MsgMen[0]	// "rfILv`..."
#define	MSMEN_AVI1			MsgMen[1]	// "rfILv`~"
#define	MSMEN_REP0			MsgMen[2]	// "L^..."  (vC)
#define	MSMEN_REP1			MsgMen[3]	// "L^~" (vC)
#define	MSMEN_REP2			MsgMen[4]	// "Đ..."  (vC)
#define	MSMEN_REP3			MsgMen[5]	// "Đ~" (vC)


// INIt@CpbZ[W ------
extern const char *MsgIni[];
// [CONFIG]
#define	MSINI_TITLE			MsgIni[0]	// "; === PC6001V ݒt@C ===\n\n"
#define	MSINI_Model			MsgIni[1]	// " @ 60:PC-6001 62:PC-6001mk2 66:PC-6601 64:PC-6001mk2SR 68:PC-6601SR"
#define	MSINI_FDD			MsgIni[2]	// " FDDڑ䐔 (0-2)"
#define	MSINI_ExtRam		MsgIni[3]	// " gRAMgp"
#define	MSINI_TurboTAPE		MsgIni[4]	// " Turbo TAPE Yes:L No:"
#define	MSINI_BoostUp		MsgIni[5]	// " BoostUp Yes:L No:"
#define	MSINI_MaxBoost60	MsgIni[6]	// " BoostUp ő{(N60[h)
#define	MSINI_MaxBoost62	MsgIni[7]	// " BoostUp ő{(N60m/N66[h)
#define	MSINI_OverClock		MsgIni[8]	// " I[o[NbN (1-1000)%"
#define	MSINI_CheckCRC		MsgIni[9]	// " CRC`FbN Yes:L No:"
#define	MSINI_RomPatch		MsgIni[10]	// " ROMpb` Yes:Ă No:ĂȂ"
// [DISPLAY]
#define	MSINI_ScrBpp		MsgIni[11]	// " J[[h 8:8bit 16:16bit 24:24bit"
#define	MSINI_Mode4Color	MsgIni[12]	// " MODE4J[[h 0:mN 1:/ 2:/ 3:sN/ 4:/sN"
#define	MSINI_ScanLine		MsgIni[13]	// " XLC Yes: No:Ȃ"
#define	MSINI_ScanLineBr	MsgIni[14]	// " XLCPx (0-100)%"
#define	MSINI_DispNTSC		MsgIni[15]	// " 4:3\ Yes:L No:"
#define	MSINI_FullScreen	MsgIni[16]	// " tXN[[h Yes:L No:"
#define	MSINI_DispStatus	MsgIni[17]	// " Xe[^Xo[ Yes:\ No:\"
#define	MSINI_FrameSkip		MsgIni[18]	// " t[XLbv"
// [SOUND]
#define	MSINI_SampleRate	MsgIni[19]	// " TvO[g (44100/22050/11025)Hz"
#define	MSINI_SoundBuffer	MsgIni[20]	// " TEhobt@TCY"
#define	MSINI_MasterVolume	MsgIni[21]	// " }X^[ (0-100)"
#define	MSINI_PsgVolume		MsgIni[22]	// " PSG (0-100)"
#define	MSINI_VoiceVolume	MsgIni[23]	// "  (0-100)"
#define	MSINI_TapeVolume	MsgIni[24]	// " TAPEj^ (0-100)"
#define	MSINI_PsgLPF		MsgIni[25]	// " PSG LPFJbgItg(0Ŗ)"
// [MOVIE]
#define	MSINI_AviRle		MsgIni[26]	// " RLEtO Yes:RLEL No:x^"
// [FILES]
#define	MSINI_ExtRom		MsgIni[27]	// " gROMt@C"
#define	MSINI_tape			MsgIni[28]	// " TAPE(LODE)t@C(NɎ}Eg)"
#define	MSINI_save			MsgIni[29]	// " TAPE(SAVE)t@C(SAVEɎ}Eg)"
#define	MSINI_disk			MsgIni[30]	// " DISKt@C(NɎ}Eg)"
#define	MSINI_printer		MsgIni[31]	// " v^o̓t@C"
#define	MSINI_fontz			MsgIni[32]	// " SptHgt@C"
#define	MSINI_fonth			MsgIni[33]	// " ptHgt@C"
// [PATH]
#define	MSINI_RomPath		MsgIni[34]	// " ROMC[Wi[pX"
#define	MSINI_TapePath		MsgIni[35]	// " TAPEC[Wi[pX"
#define	MSINI_DiskPath		MsgIni[36]	// " DISKC[Wi[pX"
#define	MSINI_ExtRomPath	MsgIni[37]	// " gROMC[Wi[pX"
#define	MSINI_ImgPath		MsgIni[38]	// " XibvVbgi[pX"
#define	MSINI_WavePath		MsgIni[39]	// " WAVEt@Ci[pX"
#define	MSINI_FontPath		MsgIni[40]	// " FONTi[pX"
// [CHECK]
#define	MSINI_CkQuit		MsgIni[41]	// " ImF Yes: No:Ȃ"
#define	MSINI_SaveQuit		MsgIni[42]	// " IINIt@Cۑ Yes: No:Ȃ"
// [KEY]
#define	MSINI_KeyRepeat		MsgIni[43]	// " L[s[g̊Ԋu(P:ms 0Ŗ)"
#define	MSINI_UsePS2KBD		MsgIni[44]	// " PS/2L[{[hg? Yes:PS/2 No:USB"
// [OPTION]
#define	MSINI_UseSoldier	MsgIni[45]	// " m̃J[gbW Yes:L No:"


// ǂłSAVEpbZ[W ------
extern const char *MsgDok[];
#define	MSDOKO_TITLE		MsgDok[0]	// "; === PC6001V ǂłSAVEt@C ===\n\n"


// ErrorpbZ[W ------
extern const char *MsgErr[];
#define	MSERR_ERROR				MsgErr[0]	// "Error"
#define	MSERR_NoError			MsgErr[1]	// "G[͂܂"
#define	MSERR_Unknown			MsgErr[2]	// "s̃G[܂"
#define	MSERR_MemAllocFailed	MsgErr[3]	// "̊mۂɎs܂"
#define	MSERR_RomChange			MsgErr[4]	// "w肳ꂽ@ROMC[WȂߋ@ύX܂\nݒmFĂ"
#define	MSERR_NoRom				MsgErr[5]	// "ROMC[W܂\nݒƃt@CmFĂ"
#define	MSERR_RomSizeNG			MsgErr[6]	// "ROMC[W̃TCYsł"
#define	MSERR_RomCrcNG			MsgErr[7]	// "ROMC[WCRCsł"
#define	MSERR_LibInitFailed		MsgErr[8]	// "CȕɎs܂"
#define	MSERR_InitFailed		MsgErr[9]	// "Ɏs܂\nݒmFĂ"
#define	MSERR_FontFailed		MsgErr[10]	// "tHg̓Ǎ݂Ɏs܂"
#define	MSERR_IniDefault		MsgErr[11]	// "INIt@C̓Ǎ݂Ɏs܂\nftHgݒŋN܂"
#define	MSERR_IniReadFailed		MsgErr[12]	// "INIt@C̓Ǎ݂Ɏs܂"
#define	MSERR_IniWriteFailed	MsgErr[13]	// "INIt@C̕ۑɎs܂"
#define	MSERR_TapeMountFailed	MsgErr[14]	// "TAPEC[W̃}EgɎs܂"
#define	MSERR_DiskMountFailed	MsgErr[15]	// "DISKC[W̃}EgɎs܂"
#define	MSERR_ExtRomMountFailed	MsgErr[16]	// "gROMC[W̃}EgɎs܂"
#define	MSERR_DokoReadFailed	MsgErr[17]	// "ǂłLOADɎs܂"
#define	MSERR_DokoWriteFailed	MsgErr[18]	// "ǂłSAVEɎs܂"
#define	MSERR_DokoDiffModel		MsgErr[19]	// "ǂłLOADɎs܂\nۑƋ@킪قȂ܂"
#define	MSERR_DokoDiffVersion	MsgErr[20]	// "ǂłLOADɎs܂\nۑPC6001Ṽo[WقȂ܂"
#define	MSERR_ReplayPlayError	MsgErr[21]	// "vCĐɎs܂"
#define	MSERR_ReplayDiffModel	MsgErr[22]	// "vCĐɎs܂\nۑƋ@킪قȂ܂"
#define	MSERR_ReplayRecError	MsgErr[23]	// "vCL^Ɏs܂"
#define	MSERR_NoReplayData		MsgErr[24]	// "vCf[^܂"



#ifdef __cplusplus
}
#endif


#endif	// OSD_H_INCLUDED
